typedef int Stream;			//עֵڻشԿκ
					//Լض
					
typedef unsigned int uint;
typedef unsigned __int32 uint32;

typedef void MOVIE;
typedef void (__cdecl *SeekFunc)(int,int);
typedef bool (__cdecl *EofFunc)(int);
typedef int	 (__cdecl *ReadFunc)(int,void *,int);

typedef void (__cdecl *InitDecodePROC)();
typedef bool (__cdecl *GetPlugInInterfacePROC)(uint32,void *);	

typedef struct
{
  int            width;
  int            height;
  int            stride;
  unsigned char *data;
}th_img_plane;

struct TheoraMovieInterface
{
	MOVIE *			(__cdecl *Open			)(Stream,SeekFunc,EofFunc,ReadFunc);
	bool			(__cdecl *GetInfo		)(MOVIE *,int &,int &,int &);
	void			(__cdecl *SetBuffer		)(MOVIE *,uint);
	double			(__cdecl *CheckUpdate	)(MOVIE *);
	void			(__cdecl *DecodeToRGB	)(MOVIE *,uchar *);
	void			(__cdecl *DecodeToBGR	)(MOVIE *,uchar *);
	void			(__cdecl *DecodeToRGBA	)(MOVIE *,uchar *);
	void			(__cdecl *DecodeToBGRA	)(MOVIE *,uchar *);
	th_img_plane *	(__cdecl *DecodeToYUV	)(MOVIE *,int &,int &);
	bool			(__cdecl *CheckEnd		)(MOVIE *);
	void			(__cdecl *Close			)(MOVIE *);
};

void __cdecl Seek(int fp,int pos)
{
	_lseek(fp,pos,SEEK_SET);	//ƶݶȡλ
}

bool __cdecl Eof(int fp)
{
	return _eof(fp);	//Ƿ
}

int __cdecl Read(int fp,void *buf,int size)
{
    return _read(fp,buf,SIZE);		//strжȡsizeֽڵ
}

HINSTANCE movie_dll=NULL;
TheoraMovieInterface *movie=NULL;

bool InitMovie()
{	
	movie_dll=LoadLibraryW(L"Movie.Theora.DLL");
	
	if(!movie_dll)return(false);
		
	GetPlugInInterfacePROC	GetInterface;
	
	GetInterface=(GetPlugInInterfacePROC)GetProcAddress(movie_dll,"GetPlugInInterface");
	
	movie=new TheoraMovieInterface;

	if(GetInterface(2,movie))
	{		
		InitDecodePROC InitDecode;

		InitDecode=(InitDecodePROC)GetProcAddress(movie_dll,"InitPlugIn");

		InitDecode();

		return(true);
	}	
		
	FreeLibrary(movie_dll);
	movie_dll=NULL;
	return(false);
}

void ClearMovie()
{
	if(movie)
	{
		delete movie;
		movie=NULL;
	}
	
	FreeLibrary(movie_dll);
	movie_dll=NULL;
}

void main()
{
	if(!InitMovie())return;
		
	int fp=_open(L"ļ",_O_BINARY|_O_RDONLY);
		
	MOVIE *mp=movie->Open(fp,Seek,Eof,Read);
	
	int width,height,fps;
	uchar *rgb_buffer;
	
	if(!mp)return;
		
	movie->GetInfo(mp,width,height,fps);		//ȡӰƬ ߡ֡
	movie->SetBuffer(mp,64*1024);				//趨һν
		
	rgb_buffer=new uchar[width*height*3];	
	
	while(movie->CheckEnd(mp)==false)
	{
		double time=movie->CheckUpdate(mp);			//ȡøµһ֡ʱ

		if(time<0)break;							//

		movie->DecodeToRGB(mp,rgb_buffer);			//һν

		//ȴtime
	}	
	
	movie->Close(mp);
	mp=NULL;
	
	_close(fp);
	
	ClearMovie();
}